---
title: 父组件给子组件传值
date: 2020-02-04 12:45:30
permalink: /pages/07b384c2e6232e07
categories: 
  - 《Vue》笔记
  - 组件
tags: 
  - null
author: 
  name: xugaoyi
  link: https://github.com/xugaoyi
---
# 父组件给子组件传值




父组件中，通过给子组件标签v-bind绑定属性的方式传入值
```html
<ComponentName v-bind:name="value"></ComponentName>
```
> 如果不使用v-bind传入的值为字符串，使用v-bind绑定传入的值为表达式。
<!-- more -->
子组件中，通过props对象接收值
```js
 props: {
    name: { // 接收父组件传入值
        type: String || ...,
        default: ''
    }
 }
```

## 单向数据流
所有的 prop 都使得其父子 prop 之间形成了一个单向下行绑定：父级 prop 的更新会向下流动到子组件中，但是反过来则不行。这样会防止从子组件意外改变父级组件的状态，从而导致你的应用的数据流向难以理解。

**子组件不能直接修改父组件传入的值**

这里有两种常见的试图改变一个 prop 的情形：

1. 这个 prop 用来传递一个初始值；这个子组件接下来希望将其作为一个本地的 prop 数据来使用。在这种情况下，最好定义一个本地的 data 属性并将这个 prop 用作其初始值：
```js
props: ['initialCounter'],
data: function () {
  return {
    counter: this.initialCounter
  }
}
```
2. 这个 prop 以一种原始的值传入且需要进行转换。在这种情况下，最好使用这个 prop 的值来定义一个计算属性：
```js
props: ['size'],
computed: {
  normalizedSize: function () {
    return this.size.trim().toLowerCase()
  }
}
```

## 父子组件间传递数据 demo
<p class="codepen" data-height="400" data-theme-id="light" data-default-tab="js,result" data-user="xugaoyi" data-slug-hash="mdJVqgg" style="height: 400px; box-sizing: border-box; display: flex; align-items: center; justify-content: center; border: 2px solid; margin: 1em 0; padding: 1em;" data-pen-title="mdJVqgg">
  <span>See the Pen <a href="https://codepen.io/xugaoyi/pen/mdJVqgg">
  mdJVqgg</a> by xugaoyi (<a href="https://codepen.io/xugaoyi">@xugaoyi</a>)
  on <a href="https://codepen.io">CodePen</a>.</span>
</p>
<script async src="https://static.codepen.io/assets/embed/ei.js"></script>
